--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/cnc19xx.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/cnc19xx.c	2015-07-15 15:16:57.551868000 +0800
@@ -0,0 +1,546 @@
+/*
+ *  arch/arm/mach-celestial/cnc19xx.c
+ *  Copyright (C) 2011 Cavium
+ */
+#include <asm/mach-types.h>
+#include <asm/mach/arch.h>
+#include <asm/mach/time.h>
+#include <asm/mach/map.h>
+#include <asm/setup.h>
+#include <linux/memblock.h>
+#include <asm/hardware/gic.h>
+#include <asm/hardware/cache-l2x0.h>
+
+#include <linux/dma-mapping.h>
+#include <linux/serial_8250.h>
+#include <linux/spi/flash.h>
+#include <linux/spi/spi.h>
+#include <linux/mmc/host.h>
+#include <linux/mmc/dw_mmc.h>
+#ifdef CONFIG_PM
+#include <linux/suspend.h>
+#endif
+
+#include <mach/hardware.h>
+#include <mach/nand.h>
+#ifdef CONFIG_SW_SUPPORT
+#include <mach/smc.h>
+#endif
+
+extern __init int platform_add_usbs(void);
+extern __init int pmem_register(void);
+
+#ifdef CONFIG_PM
+static int cnc1900_pm_suspend(suspend_state_t desired_state);
+#endif
+
+static struct map_desc cs_io_desc[] __initdata = {
+	/**
+	 * CPU CA9 Private Memory Region:
+	 */
+	{
+		.virtual	= IO_ADDRESS(CNC1900_CA9_PMR),
+		.pfn		= __phys_to_pfn(CNC1900_CA9_PMR),
+		.length		= SZ_8K,
+		.type		= MT_DEVICE,
+	},
+	/**
+	 * L2 Cache Controller:
+	 */
+	{
+		.virtual    = IO_ADDRESS(CNC1900_L2X0),
+		.pfn        = __phys_to_pfn(CNC1900_L2X0),
+		.length     = SZ_4K,
+		.type       = MT_DEVICE,
+	},
+	/**
+	 * On-Chip Peripherals I/O space:
+	 */
+	{
+		.virtual	= IO_ADDRESS(CNC1900_PERIPH_BASE),
+		.pfn		= __phys_to_pfn(CNC1900_PERIPH_BASE),
+		.length		= CNC1900_PERIPH_SIZE,
+		.type		= MT_DEVICE,
+	},
+	{
+		.virtual	=  VA_IO_MEDIA_PROCESSOR_BASE,
+		.pfn		= __phys_to_pfn(PA_IO_MEDIA_PROCESSOR_BASE),
+		.length		= IO_MEDIA_PROCESSOR_SIZE,
+		.type		= MT_DEVICE
+	},
+	{
+		.virtual	=  VA_IO_SYSTEM_CONTROL_BASE,
+		.pfn		= __phys_to_pfn(PA_IO_SYSTEM_CONTROL_BASE),
+		.length		= IO_SYSTEM_CONTROL_SIZE,
+		.type		= MT_DEVICE
+	},
+};
+
+#ifdef CONFIG_PM
+static struct platform_suspend_ops cnc1900_pm_suspend_ops = {
+    .valid = suspend_valid_only_mem,
+    .enter = cnc1900_pm_suspend,
+};
+#endif
+
+static void __init plat_map_io(void)
+{
+	iotable_init(cs_io_desc, ARRAY_SIZE(cs_io_desc));
+}
+
+#ifdef CONFIG_PM
+static int cnc1900_pm_suspend(suspend_state_t S)
+{
+    /* Note: There appear to be several drivers that do not properly suspend,
+       notably the phy0 driver and the ehci-cnc18xx driver, and so we have to
+       resort to some hackery. This function does nothing, and the actual
+       sleeping of the CPU and DDR takes place in kernel/power/suspend.c. Most
+       of the clock-gating still happens in the "lowpower" and "wakeup"
+       scripts. The final step of the lowpower script is to write 'mem' to
+       /sys/power/state, kicking off the sleeping of the CPU. The only thing
+       we do in the cnc1900 module is to copy the naptime routine to the
+       line buffer. */
+    printk(KERN_INFO "entering %s with requested state %d\n", __func__, S);
+    return 0;
+}
+#endif
+
+static struct plat_serial8250_port plat_serial[] = {
+	{
+		.membase    = (void *)IO_ADDRESS(CNC1900_UART0),
+		.mapbase    = CNC1900_UART0,
+		.irq        = UART0_IRQ,
+		.uartclk    = 45000000,
+		.regshift   = 2,
+		.iotype		= UPIO_MEM32,
+		.type       = PORT_16550A,
+		.flags      = UPF_BOOT_AUTOCONF | UPF_SKIP_TEST | UPF_FIXED_TYPE,
+	},
+#ifdef CONFIG_CELESTIAL_UART1
+	{
+		.membase    = (void *)IO_ADDRESS(CNC1900_UART1),
+		.mapbase    = CNC1900_UART1,
+		.irq        = UART1_IRQ,
+		.uartclk    = 45000000,
+		.regshift   = 2,
+		.iotype		= UPIO_MEM32,
+		.type       = PORT_16550A,
+		.flags      = UPF_BOOT_AUTOCONF | UPF_SKIP_TEST | UPF_FIXED_TYPE,
+	},
+#endif
+	{
+	}
+};
+
+static struct platform_device dev_uart = {
+	.name   = "serial8250",
+	.id     = PLAT8250_DEV_PLATFORM,
+	.dev = {
+		.platform_data = plat_serial,
+	},
+};
+
+
+
+static struct resource eth0_resources[] = {
+	{
+		.start		= CNC1900_ETH,
+		.end		= CNC1900_ETH + 0x1000 - 1,
+		.flags		= IORESOURCE_MEM,
+	}, {
+		.start		= ETH0_IRQ,
+		.flags		= IORESOURCE_IRQ,
+	},
+};
+
+static struct platform_device dev_eth0 = {
+	.name = "cnc-eth",
+	.id	= 0,
+	.resource = eth0_resources,
+	.num_resources = ARRAY_SIZE(eth0_resources),
+};
+
+#ifdef CONFIG_CELESTIAL_MULT_ETH
+static struct resource eth1_resources[] = {
+	{
+		.start		= CNC1900_ETH,
+		.end		= CNC1900_ETH + 0x1000 - 1,
+		.flags		= IORESOURCE_MEM,
+	}, {
+		.start		= ETH1_IRQ,
+		.flags		= IORESOURCE_IRQ,
+	},
+};
+
+static struct platform_device dev_eth1 = {
+	.name = "cnc-eth",
+	.id	= 1,
+	.resource = eth1_resources,
+	.num_resources = ARRAY_SIZE(eth1_resources),
+};
+#endif
+
+static struct plat_cncnand_port cncnand_ports[] = {
+	{
+		.membase = CNC1900_SM_CS0,
+		.reg_base = (void *)IO_ADDRESS(CNC1900_SMC),
+		.reg_port = (void *)IO_ADDRESS(CNC1900_SMC_CS0),
+		.cle = MASK_CLE,
+		.ale = MASK_ALE,
+	}, {
+	}
+};
+
+static struct platform_device dev_nand = {
+	.name = "cnc-nand",
+	.id	= -1,
+	.dev = {
+		.platform_data = cncnand_ports,
+	},
+};
+
+static struct resource spi_resources[] = {
+	{
+		.start		= CNC1900_SPI,
+		.end		= CNC1900_SPI + SZ_4K - 1,
+		.flags		= IORESOURCE_MEM,
+	}, {
+		.start		= SPI_IRQ,
+		.flags		= IORESOURCE_IRQ,
+	},
+};
+
+static struct platform_device dev_spi = {
+	.name = "dw_spi_mmio",
+	.id	= -1,
+	.resource = spi_resources,
+	.num_resources = ARRAY_SIZE(spi_resources),
+};
+
+static const struct flash_platform_data spi_slave_data = {
+	.name = "cnc-spi",
+	.parts = NULL,
+	.nr_parts = 0,
+};
+
+static struct spi_board_info __initdata spi_slave_info[] = {
+	{
+		.modalias = "mx25u6435f",
+		.mode = SPI_CPHA | SPI_CPOL,
+		.platform_data = &spi_slave_data,
+		.max_speed_hz = 2000000,
+	},
+};
+
+static int dwmci_init(u32 slot_id, irq_handler_t handler, void *data)
+{
+	return 0;
+}
+
+static int dwmci_get_bus_wd(u32 slot_id)
+{
+	return 4;
+}
+
+static struct dw_mci_board dwci_pdata = {
+	.num_slots			= 1,
+	.detect_delay_ms	= 200,
+	.bus_hz				= 90000000,
+//	.caps				= MMC_CAP_UHS_SDR104 | MMC_CAP_UHS_SDR50 | MMC_CAP_UHS_DDR50 | MMC_CAP_1_8V_DDR,
+	.caps				= MMC_CAP_UHS_SDR104 | MMC_CAP_UHS_SDR50 | MMC_CAP_SDIO_IRQ,
+	.caps2				= MMC_CAP2_BOOTPART_NOACC,
+	.init				= dwmci_init,
+	.get_bus_wd			= dwmci_get_bus_wd,
+};
+
+static u64 dwmci_dmamask = DMA_BIT_MASK(32);
+
+static struct resource mmc0_resources[] = {
+	{
+		.start		= CNC1900_SD0,
+		.end		= CNC1900_SD0 + SZ_4K - 1,
+		.flags		= IORESOURCE_MEM,
+	}, {
+		.start		= SD0_IRQ,
+		.flags		= IORESOURCE_IRQ,
+	},
+};
+
+struct platform_device dev_mmc0 = {
+	.name	= "dw_mmc",
+	.id		= 0,
+	.resource	= mmc0_resources,
+	.num_resources	= ARRAY_SIZE(mmc0_resources),
+	.dev = {
+		.dma_mask = &dwmci_dmamask,
+		.coherent_dma_mask	= DMA_BIT_MASK(32),
+		.platform_data	= &dwci_pdata,
+	},
+};
+
+#ifdef CONFIG_CELESTIAL_MULT_MMC
+static struct resource mmc1_resources[] = {
+	{
+		.start		= CNC1900_SD1,
+		.end		= CNC1900_SD1 + SZ_4K - 1,
+		.flags		= IORESOURCE_MEM,
+	}, {
+		.start		= SD1_IRQ,
+		.flags		= IORESOURCE_IRQ,
+	},
+};
+
+static struct platform_device dev_mmc1 = {
+	.name	= "dw_mmc",
+	.id		= 1,
+	.resource	= mmc1_resources,
+	.num_resources	= ARRAY_SIZE(mmc1_resources),
+	.dev = {
+		.dma_mask = &dwmci_dmamask,
+		.coherent_dma_mask	= DMA_BIT_MASK(32),
+		.platform_data	= &dwci_pdata,
+	},
+};
+#endif
+
+static struct resource wdt_resources[] = {
+	{
+		.start		= CNC1900_CA9_TWD,
+		.end		= CNC1900_CA9_TWD + SZ_4K - 1,
+		.flags		= IORESOURCE_MEM,
+	}, {
+		.start		= CPU_WDT_TIMER_IRQ,
+		.flags		= IORESOURCE_IRQ,
+	},
+};
+
+static struct platform_device dev_wdt = {
+	.name = "mpcore_wdt",
+	.id	= -1,
+	.resource = wdt_resources,
+	.num_resources = ARRAY_SIZE(wdt_resources),
+};
+
+static struct platform_device snd_i2s = {
+	.name = "cnc-snd-i2s",
+	.id	= -1,
+};
+
+static struct resource i2s_resources[] = {
+	{
+		.start		= CNC1900_AUDIO_I2S,
+		.end		= CNC1900_AUDIO_I2S + SZ_4K - 1,
+		.flags		= IORESOURCE_MEM,
+	},
+};
+
+static struct platform_device pcm_i2s = {
+	.name = "cnc-pcm-i2s",
+	.id	= -1,
+	.resource = i2s_resources,
+	.num_resources = ARRAY_SIZE(i2s_resources),
+};
+
+static struct resource hdmi_resources[] = {
+	{
+		.start		= CNC1900_HDMI,
+		.end		= CNC1900_HDMI + SZ_8K - 1,
+		.flags		= IORESOURCE_MEM,
+	},
+};
+
+static struct platform_device hdmi_i2s = {
+	.name = "hdmi-i2s-codec",
+	.id	= -1,
+	.resource = hdmi_resources,
+	.num_resources = ARRAY_SIZE(hdmi_resources),
+};
+
+static struct platform_device *devices[] __initdata = {
+	&dev_spi,
+	&dev_uart,
+	&dev_nand,
+	&dev_eth0,
+#ifdef CONFIG_CELESTIAL_MULT_ETH
+	&dev_eth1,
+#endif
+	&dev_mmc0,
+#ifdef CONFIG_CELESTIAL_MULT_MMC
+	&dev_mmc1,
+#endif
+	&dev_wdt,
+#ifdef CONFIG_SOUND
+	&snd_i2s,
+	&pcm_i2s,
+	&hdmi_i2s,
+#endif
+};
+
+#define CNC1900_SMEM_RESERVED 0x8001FFF0
+
+static inline void plat_restart(char mode, const char *cmd)
+{
+	volatile unsigned int *p;
+	char *m = ioremap(CNC1900_SMEM_RESERVED, 0xF);
+	memset(m, 0x0, 0xF);
+	if (cmd != NULL)
+		strcpy(m, cmd);
+
+	/* WatchDog base */
+	p = ioremap(CNC1900_CA9_TWD, 0x3C);
+	p[0x28>>2] = 0x8;
+	p[0x20>>2] = 100000;
+	p[0x28>>2] = 0xD;
+}
+
+static int l2x0_enable = 1;
+
+static int __init l2x0_disable(char *s)
+{
+	l2x0_enable = 0;
+	return 1;
+}
+__setup ("nol2x0", l2x0_disable);
+
+static void __init plat_init_machine(void)
+{
+#ifdef CONFIG_PM
+    volatile void *line_buffer_addr = NULL;
+    volatile uint32_t *s, *d;
+
+    extern void naptime(void);
+    extern void INSN_END(void);
+#endif
+#ifdef CONFIG_CACHE_L2X0
+    void __iomem *l2x0_base = (void *)IO_ADDRESS(CNC1900_L2X0);
+
+    if(l2x0_enable){
+#ifdef CONFIG_SW_SUPPORT /* Sierraware Tzone support */
+	    /* SETUP1: arg1 - tag ram latency, arg2 - data ram latency,
+	       arg3 - prefetch offset(kept as default value)  */
+	    sw_smc(SMC_CMD_L2X0SETUP1, 0x111, 0x111, 0x0);
+
+#else /* CONFIG_SW_SUPPORT */
+	    unsigned int data;
+
+		//enable dynamic clock gating and standby mode of L2 cache.
+		data = readl(l2x0_base + L2X0_POWER_CTRL); //read power control register of L2 cache
+		data = data | 0x3;                         //prepare data
+		writel(data, l2x0_base + L2X0_POWER_CTRL); //write power control register of L2 cache
+
+		/* set RAM latencies to 2 cycle */
+		writel(0x111, l2x0_base + L2X0_TAG_LATENCY_CTRL);
+		writel(0x111, l2x0_base + L2X0_DATA_LATENCY_CTRL);
+
+#endif /* CONFIG_SW_SUPPORT */
+
+		l2x0_init(l2x0_base, 0x00000000, 0xffffffff);
+	}else{
+		printk(KERN_INFO "Disable L2X0 by cmdline\n");
+	}
+#endif  /* CONFIG_CACHE_L2X0 */
+
+	platform_add_devices(devices, ARRAY_SIZE(devices));
+	spi_register_board_info(spi_slave_info, ARRAY_SIZE(spi_slave_info));
+
+	platform_add_usbs();
+
+#ifdef CONFIG_ANDROID_PMEM
+	pmem_register();
+#endif
+#ifdef CONFIG_PM
+    /* Allow 16 words storage. */
+    line_buffer_addr = ioremap_nocache(0x80000040, 0x10000);
+
+    /* Copy the storage routine into the line buffer. */
+    printk(KERN_INFO "Copying naptime routine to line buffer\n");
+    d = (volatile uint32_t *)line_buffer_addr;
+    for (s = (volatile uint32_t *)naptime; s != (volatile uint32_t *)INSN_END; ++s) {
+        *d++ = *s;
+    }
+
+    printk(KERN_INFO "calling suspend_set_ops for cnc1900\n");
+    suspend_set_ops(&cnc1900_pm_suspend_ops);
+#endif
+}
+
+static void __init plat_gic_init(void)
+{
+	gic_init(0, -1, (void *)IO_ADDRESS(CNC1900_CA9_GIC_DIST), (void *)IO_ADDRESS(CNC1900_CA9_GIC_CPUIF));
+}
+
+#ifdef CONFIG_ANDROID_PMEM
+	#define FIRST_ZONE_SIZE (PMEM_REGION & 0xFFF00000)
+#else
+	#define FIRST_ZONE_SIZE (XPORT_REGION & 0xFFF00000)
+#endif
+
+static void __init plat_fixup(struct tag *t, char **c, struct meminfo *mi)
+{
+    printk("FIRST_ZONE_SIZE is 0x%x\n", FIRST_ZONE_SIZE);
+
+#ifdef CONFIG_SW_SUPPORT
+	mi->nr_banks = 1;
+	mi->bank[0].start = 0x00;
+	mi->bank[0].size = SZ_16M;
+#ifdef SW_FEED_VIDEO
+#if (FIRST_ZONE_SIZE > SZ_128M)
+        mi->nr_banks = 2;
+	mi->bank[1].start = SZ_128M;
+	mi->bank[1].size = FIRST_ZONE_SIZE - SZ_128M;
+
+    printk("FIRST_ZONE_SIZE is 0x%x, mi->bank[1].size is 0x%x\n", FIRST_ZONE_SIZE, mi->bank[1].size);
+#if (CELESTIAL_MEM_SIZE > 256)
+	mi->nr_banks = 3;
+	mi->bank[2].start = SZ_256M;
+	mi->bank[2].size = (CELESTIAL_MEM_SIZE-256)*SZ_1M;
+#endif
+#else
+#if (CELESTIAL_MEM_SIZE > 256)
+	mi->nr_banks = 2;
+	mi->bank[1].start = SZ_256M;
+	mi->bank[1].size = (CELESTIAL_MEM_SIZE-256)*SZ_1M;
+#endif
+#endif
+#else
+	mi->nr_banks = 2;
+	mi->bank[1].start = SZ_32M;
+	mi->bank[1].size = FIRST_ZONE_SIZE - SZ_32M;
+#if (CELESTIAL_MEM_SIZE > 256)
+	mi->nr_banks = 3;
+	mi->bank[2].start = SZ_256M;
+	mi->bank[2].size = (CELESTIAL_MEM_SIZE-256)*SZ_1M;
+#endif
+#endif
+#else
+	mi->nr_banks = 1;
+	mi->bank[0].start = 0x00;
+	mi->bank[0].size = FIRST_ZONE_SIZE;
+#if (CELESTIAL_MEM_SIZE > 256)
+	mi->nr_banks = 2;
+	mi->bank[1].start = SZ_256M;
+	mi->bank[1].size = (CELESTIAL_MEM_SIZE-256)*SZ_1M;
+#endif
+#endif
+}
+
+void __init plat_reserve(void)
+{
+	memblock_reserve(PHYS_OFFSET, 0x1000000);
+}
+
+extern struct sys_timer plat_timer;
+
+MACHINE_START(CELESTIAL, "CNC1900")
+	.timer       = &plat_timer,
+	.fixup       = plat_fixup,
+	.map_io	     = plat_map_io,
+	.init_irq    = plat_gic_init,
+	.handle_irq  = gic_handle_irq,
+	.init_machine = plat_init_machine,
+#ifdef CONFIG_SW_SUPPORT
+	.reserve = plat_reserve,
+#endif
+//	.dma_zone_size = FIRST_ZONE_SIZE,
+	.restart = plat_restart,
+MACHINE_END
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/cnc19xx_mem_info.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/cnc19xx_mem_info.c
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/cnc19xx_mem_info.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/cnc19xx_mem_info.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,29 @@
+/*
+ *  arch/arm/mach-celestial/cnc19xx.c
+ *  Copyright (C) 2011 Cavium
+ */
+#include <asm/mach-types.h>
+#include <asm/mach/arch.h>
+#include <asm/mach/time.h>
+#include <asm/mach/map.h>
+#include <asm/setup.h>
+
+#include <asm/hardware/gic.h>
+#include <asm/hardware/cache-l2x0.h>
+
+#include <linux/dma-mapping.h>
+#include <linux/serial_8250.h>
+#include <linux/spi/flash.h>
+#include <linux/spi/spi.h>
+#include <linux/mmc/host.h>
+#include <linux/mmc/dw_mmc.h>
+#ifdef CONFIG_PM
+#include <linux/suspend.h>
+#endif
+
+#include <mach/hardware.h>
+#include <mach/nand.h>
+
+int mCncBlobSize = BLOB_SIZE;
+int mCncBlobBase = BLOB_BASE;
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/hotplug.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/hotplug.c
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/hotplug.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/hotplug.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,44 @@
+/*
+ * arch/arm/mach-celestial/hotplug.c
+ * Cavium CNC1900 Timer System, 2013
+ * 
+ * This file is licensed unde the terms of the GNU General Public License 
+ * version 2. This program is licensed "as is" without any warranty of 
+ * any kind, whether express or implied.
+ */
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/smp.h>
+
+#include <asm/cacheflush.h>
+#include <asm/smp_plat.h>
+#include <asm/cp15.h>
+
+extern volatile int pen_release;
+
+int platform_cpu_kill(unsigned int cpu)
+{
+	printk("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nplatform_cpu_kill\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
+
+	return 1;
+}
+
+/*
+ * platform-specific code to shutdown a CPU
+ *
+ * Called with IRQs disabled
+ */
+void platform_cpu_die(unsigned int cpu)
+{
+	printk("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nplatform_cpu_die\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
+}
+
+int platform_cpu_disable(unsigned int cpu)
+{
+	printk("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nplatform_cpu_disable\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
+	/*
+	 * we don't allow CPU 0 to be shutdown (it is still too special
+	 * e.g. clock tick interrupts)
+	 */
+	return cpu == 0 ? -EPERM : 0;
+}
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/cnc1900_clock_reg.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/cnc1900_clock_reg.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/cnc1900_clock_reg.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/cnc1900_clock_reg.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,79 @@
+#ifndef _CNC1900_CLOCK_REG_H_
+#define _CNC1900_CLOCK_REG_H_
+
+#ifdef __cplusplus
+extern "C"{
+#endif
+typedef enum _CLOCK_REG_BANK_
+{
+  CNC1900_ID_SCS                    =0xB2100000,
+
+  CLOCK_ID_BASE                     =(CNC1900_ID_SCS+(0<<2)),
+  CLOCK_PLL_BASE                    =(CNC1900_ID_SCS+(0x40<<2)),
+  CLOCK_MUX_BASE                    =(CNC1900_ID_SCS+(0x50<<2)),
+  CLOCK_RESET_BASE                  =(CNC1900_ID_SCS+(0x80<<2)),
+  PLL_PARA_BASE                     =(CNC1900_ID_SCS+(0xC0<<2)),
+  VDAC_BASE                         =(CNC1900_ID_SCS+(0xD4<<2)),
+  CPU_PWR_BASE                      =(CNC1900_ID_SCS+(0xD8<<2)),
+
+  CLOCK_ID_LO                       =(CLOCK_ID_BASE+(0<<2)),
+  CLOCK_ID_HI                       =(CLOCK_ID_BASE+(1<<2)),
+
+  //B2100100
+  CLOCK_PLL_AVS_DIV                 =(CLOCK_PLL_BASE+(1<<2)),       
+  CLOCK_AUD_DIV                     =(CLOCK_PLL_BASE+(6<<2)),
+  CLOCK_CLK_GEN_DIV                 =(CLOCK_PLL_BASE+(8<<2)),
+
+  //B2100140
+  CLOCK_PLL_CLK_EN                  =(CLOCK_MUX_BASE+(0<<2)),
+  CLK_SRC_SEL                       =(CLOCK_MUX_BASE+(1<<2)),
+  CLOCK_TVE_DIV_N		            =(CLOCK_MUX_BASE+(2<<2)),
+
+  //B2100200
+  CLOCK_SOFT_RESET                  =(CLOCK_RESET_BASE+(0<<2)),
+  CLOCK_CLK_RESET                   =(CLOCK_RESET_BASE+(1<<2)),
+  CLOCK_PLL_SLEEP_N                 =(CLOCK_RESET_BASE+(3<<2)),
+  CLOCK_HDMI_CLK_SEL                =(CLOCK_RESET_BASE+(6<<2)),
+  SB_CTRL                           =(CLOCK_RESET_BASE+(7<<2)),
+  SB_STATUS                         =(CLOCK_RESET_BASE+(8<<2)),
+
+  //B2100300
+  CPUCLK_ST_INT                     =(PLL_PARA_BASE+ (5<<2)),
+  PLL_CPU_DIV                       =(PLL_PARA_BASE+ (6<<2)),
+  PLL_TVE_PARA_Q                    =(PLL_PARA_BASE+ (7<<2)),
+  PLL_TVE_PARA_F                    =(PLL_PARA_BASE+ (8<<2)),
+  PLL_AUD_PARA_Q                    =(PLL_PARA_BASE+ (9<<2)),
+  PLL_AUD_PARA_F                    =(PLL_PARA_BASE+ (0x0A<<2)),
+  PLL_SYS_PARA_Q                    =(PLL_PARA_BASE+ (0x0B<<2)),
+  PLL_SYS_PARA_F                    =(PLL_PARA_BASE+ (0x0C<<2)),
+  PLL_DDR_PARA_Q                    =(PLL_PARA_BASE+ (0x0D<<2)),
+  PLL_DDR_PARA_F                    =(PLL_PARA_BASE+ (0x0E<<2)),
+  PLL_NEWDIV                        =(PLL_PARA_BASE+ (0x0F<<2)),
+  PLL_CODA_PARA_Q                   =(PLL_PARA_BASE+ (0x11<<2)),
+  PLL_CODA_PARA_F                   =(PLL_PARA_BASE+ (0x12<<2)),
+  CPU_PWR_MODE                   	=(PLL_PARA_BASE+ (0x20<<2)),
+  PLL_CLK_EN                   		=(PLL_PARA_BASE+ (0x50<<2)),
+
+  //B2100350
+  VDAC0_CTRL                        =(VDAC_BASE    + (0<<2)),
+  VDAC1_CTRL                        =(VDAC_BASE    + (1<<2)),
+  VDAC_CABLE_DET                    =(VDAC_BASE    + (2<<2)),
+
+  //B2100360
+  CPU_POWER_STATUS                  =(CPU_PWR_BASE + (0<<2)),
+  CPU_POWER_CTRL                    =(CPU_PWR_BASE + (1<<2)),
+  CPU_RST_CTRL                      =(CPU_PWR_BASE + (2<<2)),
+  CPU_SCU_EV_ABORT                  =(CPU_PWR_BASE + (3<<2)),
+  CPU_SCU_CHRC_CNT                  =(CPU_PWR_BASE + (4<<2)),
+  CPU_POWER_MODE                    =(CPU_PWR_BASE + (8<<2)),
+  USB_CTRL                          =(CPU_PWR_BASE + (0x0C<<2)),
+  STC_CTRL                          =(CPU_PWR_BASE + (0x10<<2)),
+
+  CLOCK_REG_SIZE = 0x1000,
+}CLOCK_REG_BANK;
+
+#ifdef __cplusplus
+}
+#endif
+#endif
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/cnc1900_df.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/cnc1900_df.h
